<?php

// Block direct access
if (!defined('ABSPATH')) { exit; }


// Add the widget to the admin dashboard
add_action('wp_dashboard_setup', 'pluginsclub_errorlog_widget_add_dashboard_widget');
function pluginsclub_errorlog_widget_add_dashboard_widget() {
    wp_add_dashboard_widget('pluginsclub_errorlog_widget', 'error_log', 'pluginsclub_errorlog_widget_display');
}

// Widget
function pluginsclub_errorlog_widget_display() {
// Confirmation popup for deleting the log file
wp_enqueue_script('error_log_empty-js', plugin_dir_url(__FILE__) . '/js/error_log_empty.js', array('jquery'), '1.1', true);

    // Path to error_log file
    $config_path = ABSPATH . 'error_log';

    // Get the contents of the error_log file
    $content = file_get_contents($config_path);

    // Count the number of occurrences of each type of error
    $notice_count = substr_count($content, "PHP Notice:");
    $warning_count = substr_count($content, "PHP Warning:");
    $fatal_count = substr_count($content, "PHP Fatal error:");
    $database_count = substr_count($content, "WordPress database error:");
    $total_errors = $notice_count + $warning_count + $fatal_count + $database_count;

    // Get the size of the error_log file
    $file_size = filesize($config_path);

    // Convert the file size to a human-readable format
    $human_readable_size = size_format($file_size);

    ?>
<style>
h4 {
border-bottom: 1px dotted;
}
a {
text-decoration: none;
}
.button-icon {
    vertical-align:middle;
}
</style>
<h4 style="color:green;">Notices: <b style="float: right;"> <?php echo $notice_count; ?></b></h4>
<h4 style="color:orange;">Warnings: <b style="float: right;"> <?php echo $warning_count; ?></b></h4>
<h4 style="color:red;">Fatals: <b style="float: right;"> <?php echo $fatal_count; ?></b></h4>
<h4 style="color:blue;">Databases: <b style="float: right;"> <?php echo $database_count; ?></b></h4>
<h3>Total Errors: <b style="float: right;"> <a href="<?php echo admin_url('tools.php?page=error_log'); ?>"><?php echo $total_errors; ?></a></b></h3>
<h3>Log Size: <b style="float: right;"> <?php echo $human_readable_size; ?></b></h3>
<hr>
<p style="text-align: center;">
    <a class="button-secondary" href="<?php echo esc_url(admin_url('tools.php?page=error_log')) ?>"><span class="button-icon dashicons dashicons-text"></span> View error_log</a>   
    <a href="<?php echo esc_url(site_url('/wp-admin/admin-ajax.php?action=download_error_log')); ?>" class="button-primary" id="download-error-log"><span class="button-icon dashicons dashicons-download"></span> Download File</a>
    <button class="button-secondary" id="empty-error-log"><span class="button-icon dashicons dashicons-trash"></span> Empty Log</button>
</p>


<?php
// On POST request this truncates the error_log file
add_action('wp_ajax_empty_error_log_widget', 'empty_error_log_ajax_handler_widge');
function empty_error_log_ajax_handler_widge() {
  // Check permissions
  if (!current_user_can('manage_options')) {
    wp_send_json_error('Insufficient permissions.');
  }

  // Path to error_log file
  $config_path = ABSPATH . 'error_log';

  // Empty the error log file
  file_put_contents($config_path, '');

  wp_send_json_success('Error log emptied successfully.');
}

}